#!/bin/bash -e
#============================================================================#
# Create filelists for ghc module packaging                                  #
#============================================================================#
# (C) Denis Smirnov <mithraen@freesource.info>          http://mithraen.ru/  #
#============================================================================#
buildroot=$1
dyn_libdir=$2
pkg_libdir=$3
listdir=$4
pkg_name=$5
version=$6
conf_file=$7

pushd $buildroot
    # libdir would be not exists if package contains only library, without binaries
    > $listdir/$pkg_name-files.prof
    > $listdir/$pkg_name-files.nonprof
    if [ -d .$pkg_libdir ]; then
        find .$dyn_libdir \( -name '*.so' \) | sed s/^.// >> $listdir/$pkg_name-files.prof
        find .$pkg_libdir \( -name '*_p.a' -o -name '*.p_hi' \) | sed s/^.// >> $listdir/$pkg_name-files.prof
        find .$pkg_libdir -type d | sed 's/^./%dir /' >> $listdir/$pkg_name-files.nonprof
        find .$pkg_libdir ! \( -type d -o -name '*_p.a' -o -name '*.p_hi' \) | sed s/^.// >> $listdir/$pkg_name-files.nonprof
    fi
    cat $listdir/$pkg_name-files.prof >> $listdir/$pkg_name-files.nonprof
    if [ -f .$conf_file ]; then
	echo .$conf_file >> $listdir/$pkg_name-files.nonprof
    fi
#    find .$pkg_libdir
    #sed 's,^/,%exclude /,' $listdir/$pkg_name-files.prof >> $listdir/$pkg_name-files.nonprof
    (
	cat $listdir/$pkg_name-files.nonprof
        find ./usr/bin -type f ||:
        find ./usr/share/$pkg_name-$version ||:
        find ./usr/share/doc/$pkg_name-$version ||:
    ) \
     | sed 's/^\.//'  \
     > $listdir/$pkg_name-files.all
popd
